#include <avr/io.h>
#include "config.h"
#include <stdlib.h>

.global ReadADC
.global W5msReadADC;
.global W20msReadADC;

// ANZ_MES = 44 fr hchste Genauigkeit, Summe von 44 einzelnen Messungen
// ANZ_MES = 22 fr mittlere Genauigkeit, 22 einzelne Messungen, Ergebnis wird zustzlich mit 2 multipliziert
// ANZ_MES = 11 fr hchste Geschwindigkeit, 11 einzelne Messungen, Ergebnis wird mit 4 multipliziert
// Durch die anschliessende Division durch 9 wird jeweils eine mV Auflsung erreicht.

#define ANZ_MES 44


// unsigned int W5msReadADC(uint8_t mux) {
//   wait5ms();
W5msReadADC:
    	rcall	wait5ms;
//   return (ReadADC(mux)); }
        rjmp	ReadADC

//unsigned int W20msReadADC(uint8_t mux) {
//   wait20ms();
W20msReadADC:
	rcall	wait20ms;
//   return (ReadADC(mux));
    // luft weiter in ReadADC 


//unsigned int ReadADC(uint8_t mux)
// { //ADC-Wert des angegebenen Kanals auslesen und als unsigned int zurckgeben
//  ADMUX = mux | (1<<REFS0);
ReadADC:
       	ori	r24, 1<<REFS0	
#if ADMUX < 32
	out	ADMUX,r24
#else
 	sts	ADMUX, r24
#endif
//  unsigned int adcx = 0;
     	ldi	r24, 0x00	; 0
      	ldi	r25, 0x00	; 0
       	ldi	r20, 0x00	; 0

//  for(uint8_t j=0;j<(ANZ_MES+1);j++)
//    {	//ANZ_MESS Messungen; fr bessere Genauigkeit
//     ADCSRA |= (1<<ADSC);		//starte Conversion
getad:
#if ADCSRA < 32
	sbi	ADCSRA,ADSC	
#else
 	lds	r18, ADCSRA
      	ori	r18, (1<<ADSC)
 	sts	ADCSRA, r18
#endif
//     while (ADCSRA&(1<<ADSC));		//warte
lop:
#if ADCSRA < 32
	sbic	ADCSRA,ADSC
#else
 	lds	r18, ADCSRA
       	sbrc	r18, ADSC
#endif
       	rjmp	lop    
//     adcx += ADCW;
#if ADCH < 32
	in	r18,ADCL; 
	in	r19,ADCH; 
#else
	lds	r18, ADCL
 	lds	r19, ADCH
#endif
        cpi     r20,0
        breq    count			// 1. Messung verwerfen
       	add	r24, r18
       	adc	r25, r19

//  for(uint8_t j=0;j<ANZ_MES;j++)
count:
       	subi	r20, 0xFF	; 255
       	cpi	r20, ANZ_MES+1
      	brne	getad 
//  return adcx/9;
//  }
#if ANZ_MES == 22
	add	r24,r24		;*2
	adc	r25,r25
#endif
#if ANZ_MES == 11
	add	r24,r24		;*2
	adc	r25,r25
	add	r24,r24		;*2
	adc	r25,r25
#endif
       	ldi	r22, 0x09	; 9
       	ldi	r23, 0x00	; 0
       	rcall	__udivmodhi4
       	movw	r24, r22
       	ret

